package ed_cr311h3.img_futils;

import futils.Futil;

import java.io.File;
import java.io.FileFilter;

public class ListFiles
{
    //common windows image file extensions
    private static final String[] winImgFileExtensionList =
            {"GIF", "JPG", "PNG", "BMP", "ICO", "JNG",
             "JPEG", "PCX", "PSD", "PSP", "TIF", "TIFF", "PGM"};

    public static void main( String args[] )
    {
        File list[] = getImgFileList( "select an image directory" );
        for ( int i = 0; i < list.length; i++ )
        {
            System.out.println( list[i] );
        }
    }

    public static File [] getFileList( String prompt )
    {
        File f = Futil.getReadDir( prompt );
        return f.listFiles();
    }

    /**
     * getImgFileList will retrieve a list of files from a directory, filtered
     * to include only files with a common image file extension
     *
     * @param prompt - title prompt of file browser window
     * @return File[] - a list of files filtered to include only files with a common img extension
     */
    public static File[] getImgFileList( String prompt )
    {
        FileFilter fil = new FileFilter()
        {
            public boolean accept(File pathname)
            {
                if( pathname.isFile() )
                {
                    int idx = pathname.getPath().lastIndexOf('.');

                    //System.out.println(pathname.getPath());

                    if( idx > -1 )
                    {
                        String ext = pathname.getPath().substring(idx + 1).toUpperCase();
                        //System.out.println( ext );

                        for( int i = 0; i < winImgFileExtensionList.length; i++ )
                        {
                            if( ext.equals( winImgFileExtensionList[i]) )
                            {
                                return true;
                            }
                        }
                    }
                }
                return false;
            }
        };

        File f = Futil.getReadDir(  prompt );
        return f.listFiles(fil);
    }
}