package net.rmi.rjs.pk.rmiFileTransfer;


import futils.Futil;
import net.rmi.rjs.pk.LusCs.*;
import utils.SystemUtils;

import java.io.File;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
 * Created by IntelliJ IDEA. User: pkrepszt Date: Mar 13, 2005 Time:
 * 7:25:37 PM To change this template use File | Settings | File
 * Templates.
 */
public class FileServerImplementation
        extends UnicastRemoteObject
        implements FileTransInterface {

    public static String REMOTE_NAME = "RmiFileServerMain";
    private boolean onTheGrid = true;
    public FileServerImplementation()
            throws RemoteException {
    }
    //todo this is part of your final. You need to test this!
    public boolean isAwake() throws RemoteException{
        return true;
    }

    public void setIsOnTheGrid(boolean b) throws RemoteException {
        onTheGrid = b;
        System.out.println("On the grid = " +b);
    }

    public boolean getIsOnTheGrid() throws RemoteException {
        return onTheGrid; 
    }

    /**
     * This is implements in the computer server in order
     * to obtain a job, executed and return the answer to the LUS
     * via the putFile.
     * @param rj
     * @throws RemoteException
     */
    public void putJob(RemoteJob rj, String wsAnwserURL) throws RemoteException {
        File f = new File(SystemUtils.getUserHome() +
                SystemUtils.getDirectorySeparator() +
                rj.getJarFileName());
        Futil.writeBytes(f, rj.getJarContents());
        //new CSAnswerFactory(f, rj.getReturnAddress(),wsAnwserURL);
    }
    /**
     * Call this method to put data into the file system of
     * a remote server.
     * Use this to put an answer into the LUS from the CS.
     *
     * @param fileName
     * @param data
     * @throws RemoteException
     */
    public void putFile(String fileName, byte data[])
            throws RemoteException {
        if (data == null) System.out.println("Data=null!");
        File f = new File(
                SystemUtils.getUserHome() +
                SystemUtils.getDirectorySeparator() +
                fileName);
        Futil.writeBytes(f, data);
        System.out.println("wrote file to Lus:" + f.getAbsolutePath());
    }

    public String putURL(String URL, String webServerIP, String lusIpAddress)
            throws RemoteException {
        System.out.println("new CSAnswerFactory(URL, webServerIP, lusIpAddress);");
       new CSAnswerFactory(URL, webServerIP, lusIpAddress);
       return URL;
    }
    public BenchMarkBean getBenchMarkBean() throws RemoteException {
         BenchMarkUtils bmu = new BenchMarkUtils();

        final BenchMarkBean benchMarkBean = bmu.getBenchMarkBean();
        System.out.println("benchMarkBean="+benchMarkBean);
        return benchMarkBean;
    }
    public File getFile(String fileName, String ip) throws RemoteException {
        return new File(
                SystemUtils.getUserHome() +
                SystemUtils.getDirectorySeparator() +
                fileName);
    }

    public void runLusAnwserFactory(String fileName, byte data[], String wsAnwserURL){
        File f = new File(
                SystemUtils.getUserHome() +
                SystemUtils.getDirectorySeparator() +
                fileName);
        Futil.writeBytes(f, data);
        new LusAnwserFactory(f, wsAnwserURL);

    }

    public static void main(String[] args) {
        try {
            FileServerImplementation fsi = new FileServerImplementation();
            System.out.println(fsi.getBenchMarkBean().toString()  );
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
}

